mainly alerting improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 # [[ -d /home/iank/.iank/e/e ]] mounts it unnecessarily, so use this.
242 if grep -qF /home/iank/.iank/e/e /etc/auto.iank /etc/exports &>/dev/null; then
243 export EMACSDIR=/home/iank/.iank/e/e
244 fi
245 path-add $bashrc_dir
246 fi
247 fi
248
249 # if someone exported $SOE (stop on error), catch errors.
250 #
251 # Note, on debian this results in the following warning when in ssh,
252 # hich I haven't figured out how to fix. It doesn't happen if we source
253 # after the shell has started
254 #
255 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
256 # bash: warning: cannot start debugger; debugging mode disabled
257 if [[ $SOE ]]; then
258 if [[ -e /a/bin/errhandle/err ]]; then
259 source /a/bin/errhandle/err
260 fi
261 fi
262
263 # based on readme.debian. dunno if this will break on other distros.
264 if [[ -s /usr/share/wcd/wcd-include.sh ]]; then
265 source /usr/share/wcd/wcd-include.sh
266 fi
267
268
269 mysrc() {
270 local path dir file
271 path=$1
272 dir=${path%/*}
273 file=${path##*/}
274 if [[ -s $path ]]; then
275 source $path
276 elif [[ -s $bashrc_dir/$file ]]; then
277 source $bashrc_dir/$file
278 fi
279 }
280
281
282 mysrc /a/bin/small-misc-bash/ll-function
283 mysrc /a/bin/distro-functions/src/package-manager-abstractions
284
285
286 # * functions
287 ccomp() { # copy completion
288 local src=$1
289 local c
290 shift
291 if ! c=$(complete -p $src 2>/dev/null); then
292 _completion_loader $src &>/dev/null ||:
293 c=$(complete -p $src 2>/dev/null) || return 0
294 fi
295 # remove $src( .*|$)
296 c=${c% $src}
297 c=${c%% $src *}
298 eval $c $*
299 }
300
301
302 ..() { c ..; }
303 ...() { c ../..; }
304 ....() { c ../../..; }
305 .....() { c ../../../..; }
306 ......() { c ../../../../..; }
307
308 chere() {
309 local f path
310 for f; do
311 path=$(readlink -e "$f")
312 echo "cat >$path <<'EOF'"
313 cat "$f"
314 echo EOF
315 done
316 }
317
318
319 # file cut copy and paste, like the text buffers :)
320 # I havnt tested these.
321 _fbufferinit() { # internal use
322 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
323 rm -rf "${my_f_tempdir:?}"/*
324 }
325 fcp() { # file cp
326 _fbufferinit
327 cp "$@" "$my_f_tempdir"/
328 }
329 fct() { # file cut
330 _fbufferinit
331 mv "$@" "$my_f_tempdir"/
332 }
333 fpst() { # file paste
334 [[ $2 ]] && { echo too many arguments; return 1; }
335 target=${1:-.}
336 cp "$my_f_tempdir"/* "$target"
337 }
338
339 _khfix_common() {
340 local host ip port file key
341 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
342 file=$(readlink -f ~/.ssh/known_hosts)
343 if [[ ! $ip ]]; then
344 echo "khfix: ssh failed"
345 return 1
346 fi
347 if [[ $port != 22 ]]; then
348 ip_entry="[$ip]:$port"
349 host_entry="[$host]:$port"
350 else
351 ip_entry=$ip
352 host_entry=$host
353 fi
354 tmpfile=$(mktemp)
355 if [[ $host != $ip ]]; then
356 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
357 if [[ $key ]]; then
358 grep -Fv "$key" "$file" | sponge "$file"
359 fi
360 fi
361 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
362 if [[ $key ]]; then
363 grep -Fv "$key" "$file" | sponge "$file"
364 fi
365 ll ~/.ssh/known_hosts
366 rootsshsync
367 }
368 khfix() { # known hosts fix
369 _khfix_common "$@" || return 1
370 ssh $1 :
371 }
372 khcopy() {
373 _khfix_common "$@"
374 ssh-copy-id $1
375 }
376
377 a() {
378 local x
379 x=$(readlink -nf "${1:-$PWD}")
380 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
381 echo -n "$x" | xclip -selection clipboard
382 echo -n "$x" | xclip
383 }
384
385 # a1 = awk {print $1}
386 for field in {1..20}; do
387 eval a$field"() { awk '{print \$$field}'; }"
388 done
389 # h1 = head -n1
390 for num in {1..9}; do
391 eval h$num"() { head -n$num; }"
392 done
393
394
395 b() {
396 # backwards
397 c -
398 }
399
400 hexipv4() {
401 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
402 }
403
404 vp9() {
405 local f out outdir in
406 outdir=vp9
407 case $1 in
408 --out)
409 outdir=$2
410 shift 2
411 ;;
412 esac
413 m mkdir -p $outdir
414 for f; do
415 out=$PWD/$outdir/$f
416 in=$PWD/$f
417 m cd $(mktemp -d)
418 pwd
419 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
420 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
421 cd -
422 done
423 }
424
425 utcl() { # utc 24 hour time to local hour 24 hour time
426 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
427 }
428
429 # c. better cd
430 if type -p wcd &>/dev/null; then
431 if [[ $LC_INSIDE_EMACS ]]; then
432 c() { wcd -c -z 50 -o "$@"; }
433 else
434 # lets see what the fancy terminal does from time to time
435 c() { wcd -c -z 50 "$@"; }
436 fi
437 else
438 c() { cd "$@"; }
439 fi
440 ccomp cd c
441
442 c4() { c /var/log/exim4; }
443
444 caa() { git commit --amend --no-edit -a; }
445
446 cf() {
447 for f; do
448 hr
449 echo "$f"
450 hr
451 cat "$f"
452 done
453 }
454 caf() {
455 # shellcheck disable=SC2033
456 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
457 -o -name .hg -prune -o -name .editor-backups -prune \
458 -o -name .undo-tree-history -prune \) \
459 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
460
461 }
462 ccomp cat cf caf
463
464 calc() { echo "scale=3; $*" | bc -l; }
465 # no having to type quotes, but also no command history:
466 clc() {
467 local x
468 read -r x
469 echo "scale=3; $x" | bc -l
470 }
471
472 cam() {
473 git commit -am "$*"
474 }
475
476 ccat () { # config cat. see a config without extra lines.
477 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
478 }
479 ccomp grep ccat
480
481 chrbind() {
482 local d
483 # dev/pts needed for pacman signature check
484 for d in dev proc sys dev/pts; do
485 [[ -d $d ]]
486 if ! mountpoint $d &>/dev/null; then
487 m s mount -o bind /$d $d
488 fi
489 done
490 }
491 chumount() {
492 local d
493 # dev/pts needed for pacman signature check
494 for d in dev proc sys dev/pts; do
495 [[ -d $d ]]
496 if mountpoint $d &>/dev/null; then
497 m s umount $d
498 fi
499 done
500 }
501
502
503 _cdiff-prep() {
504 # join options which are continued to multiples lines onto one line
505 local first=true
506 while IFS= read -r line; do
507 # remove leading spaces/tabs. assumes extglob
508 if [[ $line == "[ ]*" ]]; then
509 line="${line##+( )}"
510 fi
511 if $first; then
512 pastline="$line"
513 first=false
514 elif [[ $line == *=* ]]; then
515 echo "$pastline" >> "$2"
516 pastline="$line"
517 else
518 pastline="$pastline $line"
519 fi
520 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
521 echo "$pastline" >> "$2"
522 }
523
524 cdiff() {
525 # diff config files,
526 # setup for format of postfix, eg:
527 # option = stuff[,]
528 # [more stuff]
529 local pastline unified f1 f2
530 unified="$(mktemp)"
531 f1="$(mktemp)"
532 f2="$(mktemp)"
533 _cdiff-prep "$1" "$f1"
534 _cdiff-prep "$2" "$f2"
535 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
536 while IFS= read -r line; do
537 # the default bright red / blue doesnt work in emacs shell
538 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
539 done < "$unified"
540 }
541
542
543 cat-new-files() {
544 local start=$SECONDS
545 local dir="$1"
546 inotifywait -m "$dir" -e create -e moved_to |
547 # shellcheck disable=SC2030
548 while read -r filedir _ file; do
549 cat "$filedir$file"
550 hr
551 calc $((SECONDS - start)) / 60
552 sleep 5
553 done
554
555 }
556
557 # shellcheck disable=SC2032
558 chown() {
559 # makes it so chown -R symlink affects the symlink and its target.
560 if [[ $1 == -R ]]; then
561 shift
562 command chown -h "$@"
563 command chown -R "$@"
564 else
565 command chown "$@"
566 fi
567 }
568
569 cim() {
570 git commit -m "$*"
571 }
572
573 cl() {
574 # choose recent directory. cl = cd list
575 c =
576 }
577
578 d() { builtin bg "$@"; }
579 ccomp bg d
580
581 dc() {
582 diff --strip-trailing-cr -w "$@" # diff content
583 }
584 ccomp diff dc
585
586 despace() {
587 local x y
588 for x in "$@"; do
589 y="${x// /_}"
590 safe_rename "$x" "$y"
591 done
592 }
593
594 dig() {
595 command dig +nostats +nocmd "$@"
596 }
597 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
598 digsort() {
599 local sec
600 sec=
601 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
602 if [[ $l == [^\;]* ]]; then
603 sec+="$l"$'\n'
604 else
605 if [[ $sec ]]; then
606 printf "%s" "$sec" | sort
607 sec=
608 fi
609 printf "%s\n" "$l"
610 fi
611 done
612 }
613 ccomp dig digsort
614 # compare digs to the 2 servers
615 # usage: digdiff @server1 @server2 DIG_ARGS
616 # note: only the soa master nameserver will respond with
617 # ra "recursive answer" flag. That difference is meaningless afaik.
618 digdiff() {
619 local s1 s2
620 s1=$1
621 shift
622 s2=$1
623 shift
624 digsort $s1 "$@" | tee /tmp/digdiff
625 diff -u /tmp/digdiff <(digsort $s2 "$@")
626 }
627
628 dt() {
629 date "+%A, %B %d, %r" "$@"
630 }
631 ccomp date dt
632
633 dus() { # du, sorted, default arg of
634 du -sh ${@:-*} | sort -h
635 }
636 ccomp du dus
637
638
639 e() { echo "$@"; }
640
641 # echo args
642 ea() {
643 if (( ! $# )); then
644 echo no args
645 fi
646 for arg; do
647 printf "%qEOL\n" "${arg}"
648 printf "%s" "${arg}" |& hexdump -C
649 done
650 }
651 # echo vars. print var including escapes, etc
652 ev() {
653 if (( ! $# )); then
654 echo no args
655 fi
656 for arg; do
657 if [[ -v $arg ]]; then
658 printf "%qEOL\n" "${!arg}"
659 printf "%s" "${!arg}" |& hexdump -C
660 else
661 echo arg $arg is unset
662 fi
663 done
664 }
665
666 ediff() {
667 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
668 emacs --eval "(ediff-files \"$1\" \"$2\")"
669 }
670
671 # mail related
672 etail() {
673 tail -F /var/log/exim4/mainlog -n 200 "$@"
674 }
675 ccomp tail etail
676
677 # print exim old pids
678 eoldpids() {
679 local configtime pid piduptime now daemonpid
680 printf -v now '%(%s)T' -1
681 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
682 if [[ -s /run/exim4/exim.pid ]]; then
683 daemonpid=$(cat /run/exim4/exim.pid)
684 fi
685 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
686 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
687 if [[ $pid == $daemonpid ]]; then
688 continue
689 fi
690 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
691 if (( configtime > now - piduptime )); then
692 echo $pid
693 fi
694 done
695 }
696
697 # exim tail but only watch lines from new pids
698 etailnew() {
699 local pid oldpids
700 for pid in $(eoldpids); do
701 oldpids+="$pid|"
702 done
703 if [[ $oldpids ]]; then
704 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
705 else
706 etail
707 fi
708 }
709 # exim watch as old pids go away
710 ewatchold() {
711 local configtime pid piduptime now
712 local -i count
713 local -a oldpids
714 count=0
715 while true; do
716 oldpids=($(eoldpids))
717 if (( ! ${#oldpids[@]} )); then
718 return
719 fi
720 # print the date every 20 iterations
721 if (( ! count % 20 )); then
722 date
723 fi
724 count+=1
725 ps -f -p "${oldpids[*]}"
726 sleep 1
727 done
728 }
729
730 eless() {
731 less /var/log/exim4/mainlog
732 }
733 ccomp less eless
734 eqcat() {
735 exiqgrep -i -o 60 | while read -r i; do
736 hlm exim -Mvc $i
737 echo
738 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
739 done
740 }
741 eqrmf() {
742 exiqgrep -i | xargs exim -Mrm
743 }
744
745 econfdevnew() {
746 rm -rf /tmp/edev
747 mkdir -p /tmp/edev/etc
748 cp -ra /etc/exim4 /tmp/edev/etc
749 cp -ra /etc/alias* /tmp/edev/etc
750 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
751 econfdev
752 }
753 econfdev() {
754 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
755 }
756
757
758
759 # shellcheck disable=SC2032
760 f() {
761 # cd forward
762 c +
763 }
764
765 fa() {
766 # find array. make an array of file names found by find into $x
767 # argument: find arguments
768 # return: find results in an array $x
769 while read -rd ''; do
770 x+=("$REPLY");
771 done < <(find "$@" -print0);
772 }
773
774 faf() { # find all files. use -L to follow symlinks
775 find "$@" -not \( -name .svn -prune -o -name .git -prune \
776 -o -name .hg -prune -o -name .editor-backups -prune \
777 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
778 }
779
780 # todo: id like to do maybe a daily or hourly cronjob to
781 # check that my history file size is increasing. Ive had it
782 # inexplicably truncated in the past.
783 histrm() {
784 history -n
785 history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/'
786 read -p "press anything but contrl-c to delete"
787 for entry in $(history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/ { print a }' | tac); do
788 history -d $entry
789 done
790 history -w
791 }
792
793 # mail related
794 frozen() {
795 rm -rf /tmp/frozen
796 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
797 sudo exim -Mvl $id
798 echo
799 sudo exim -Mvh $id
800 echo
801 sudo exim -Mvb $id
802 echo -e '\n\n##############################\n'
803 done | tee -a /tmp/frozen
804 }
805 frozenrm() {
806 local ids=()
807 while read -r line; do
808 printf '%s\n' "$line"
809 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
810 done < <(s mailq)
811 echo "sleeping for 2 in case you change your mind"
812 sleep 2
813 sudo exim -Mrm "${ids[@]}"
814 }
815
816 funce() {
817 # like -e for functions. returns on error.
818 # at the end of the function, disable with:
819 # trap ERR
820 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
821 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
822 trap ERR
823 return' ERR
824 }
825
826 getdir () {
827 local help="Usage: getdir [--help] PATH
828 Output the directory of PATH, or just PATH if it is a directory."
829 if [[ $1 == --help ]]; then
830 echo "$help"
831 return 0
832 fi
833 if [[ $# -ne 1 ]]; then
834 echo "getdir error: expected 1 argument, got $#"
835 return 1
836 fi
837 if [[ -d $1 ]]; then
838 echo "$1"
839 else
840 local dir
841 dir="$(dirname "$1")"
842 if [[ -d $dir ]]; then
843 echo "$dir"
844 else
845 echo "getdir error: directory does not exist"
846 return 1
847 fi
848 fi
849 }
850
851 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
852 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
853 local root
854 root=$(gitroot) || return 1 # function to set gitroot
855 builtin cd "$root"
856 git symbolic-ref HEAD refs/heads/$1
857 rm .git/index
858 git clean -fdx
859 }
860
861 # shellcheck disable=SC2120
862 gitroot() {
863 local help="Usage: gitroot [--help]
864 Print the full path to the root of the current git repo
865
866 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
867 and works in older versions of git which did not have that."
868 if [[ $1 == --help ]]; then
869 echo "$help"
870 return
871 fi
872 local p
873 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
874 [[ $p != /* ]] && p=$PWD
875 echo "${p%%/.git}"
876 }
877
878 g() {
879
880 # todo: patch emacs so it will look elsewhere. this is kinda sad:
881 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
882
883 local args gdb=false
884
885 if [[ $EMACSDIR ]]; then
886 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
887 fi
888
889 if [[ $DISPLAY ]]; then
890 args=-n
891 fi
892
893 if (( $# == 0 )); then
894 args+=" -c"
895 fi
896 # duplicate -c, but oh well
897 if ! pgrep -u $EUID emacsclient; then
898 if (( $# == 0 )) && type -p gdb &>/dev/null; then
899 gdb=true
900 else
901 args+=" -c"
902 fi
903 fi
904 if [[ $EMACSDIR ]]; then
905 # Alter the path here, otherwise the nfs mount gets triggered on the
906 # first path lookup when emacs is not being used.
907 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
908 else
909 if $gdb; then
910 # due to a bug, we cant debug from the start unless we get a new gdb
911 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
912 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
913 m emacsclient -a "" $args "$@"
914 sleep 1
915 cd /a/opt/emacs-$(distro-name)$(distro-num)
916 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
917 cd -
918 else
919 m emacsclient -a "" $args "$@"
920 fi
921 fi
922 }
923
924 # force terminal version
925 gn() {
926 g -n "$@"
927 }
928
929 gmacs() {
930 # quit will prompt if the program crashes.
931 gdb -ex=r -ex=quit --args emacs "$@"; r;
932 }
933
934 gdkill() {
935 # kill the emacs daemon
936 pk1 emacs --daemon
937 }
938
939 gr() {
940 grep -iIP --color=auto "$@" || return $?
941 }
942 grr() { # grep recursive
943 # Don't return 1 on nonmatch because this is meant to be
944 # interactive, not in a conditional.
945 if [[ ${#@} == 1 ]]; then
946 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
947 else
948 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
949 fi
950 }
951 ccomp grep gr grr
952
953 rg() { grr "$@"; }
954 ccomp grep rg
955
956 hr() { # horizontal row. used to break up output
957 printf "$(tput setaf 5 2>/dev/null ||:)â–ˆ$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
958 echo
959 }
960 # highlight
961 hl() {
962 local col input_len=0
963 for arg; do
964 input_len=$((input_len + 1 + ${#arg}))
965 done
966 col=$((60 - input_len))
967 printf "\e[1;97;41m%s" "$*"
968 if (( col > 0 )); then
969 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
970 fi
971 echo
972 }
973 hlm() { hl "$*"; "$@"; }
974
975 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
976
977
978 # get latest hub and run it
979 # main command to use:
980 # hub pull-request --no-edit
981 # --no-edit means to use the first commit\'s message as the pull request message.
982 # If that fails, try doing
983 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
984 # where branch is usually master. it does the pr against your current branch.
985 #
986 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
987 # it\'s at ~/.config/hub
988 hub() {
989 local up uptar updir p
990 p=/github/hub/releases/
991 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
992 uptar=${up##*/}
993 updir=${uptar%.tgz}
994 if [[ ! -e /a/opt/$updir ]]; then
995 rm -rf /a/opt/hub-linux-amd64*
996 wget -P /a/opt $up
997 tar -C /a/opt -zxf /a/opt/$uptar
998 rm -f /a/opt/$uptar
999 fi
1000 if ! which hub &>/dev/null; then
1001 sudo /a/opt/$updir/install
1002 fi
1003
1004 # save token across computers
1005 if [[ ! -L ~/.config/hub ]]; then
1006 if [[ -e ~/.config/hub ]]; then
1007 mv ~/.config/hub /p/c/subdir_files/.config/
1008 fi
1009 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1010 conflink
1011 fi
1012 fi
1013 command hub "$@"
1014 }
1015
1016 i() { git "$@"; }
1017 ccomp git i
1018
1019 ic() {
1020 # fast commit all
1021 git commit -am "$*"
1022 }
1023
1024 ipp() {
1025 git pull
1026 git push
1027 }
1028
1029
1030 ifn() {
1031 # insensitive find
1032 find -L . -not \( -name .svn -prune -o -name .git -prune \
1033 -o -name .hg -prune -o -name .editor-backups -prune \
1034 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1035 }
1036
1037 ifd() {
1038 # insensitive find directory
1039 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1040 -o -name .hg -prune -o -name .editor-backups -prune \
1041 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1042 }
1043
1044
1045 ipdrop() {
1046 sudo iptables -A INPUT -s $1 -j DROP
1047 }
1048
1049
1050 istext() {
1051 grep -Il "" "$@" &>/dev/null
1052 }
1053
1054 jtail() {
1055 journalctl -n 10000 -f "$@"
1056 }
1057 jr() { journalctl "$@" ; }
1058 jrf() { journalctl -f "$@" ; }
1059 jru() {
1060 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1061 }
1062
1063 l() {
1064 if [[ $PWD == /[iap] ]]; then
1065 command ls -A --color=auto -I lost+found "$@"
1066 else
1067 command ls -A --color=auto "$@"
1068 fi
1069 }
1070
1071 lcn() { locate -i "*$**"; }
1072
1073 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1074
1075 lt() { ll -tr "$@"; }
1076
1077 lld() { ll -d "$@"; }
1078
1079 ccomp ls l lg lt lld ll
1080
1081 # low recursively
1082 lowr() {
1083 local f dirs i a
1084 local -a all
1085 for dirs in false true; do
1086 for f; do
1087 if [[ -d $f ]]; then
1088 all=("$f"/**)
1089 # reverse the order to rename the nested dirs first.
1090 # note: 0 element is the dir itself
1091 for ((i=${#all[@]}-1; i>=1; i--)); do
1092 a="${all[i]}"
1093 if $dirs && [[ -d $a ]]; then
1094 # e dirs low "$a" # debug
1095 low "$a"
1096 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1097 # debug
1098 # e not dirs low "$a" # debug
1099 low "$a"
1100 fi
1101 done
1102 fi
1103 # just rename all the top level args on the second pass
1104 if $dirs; then
1105 # e final dirs low "$f" # debug
1106 low "$f"
1107 fi
1108 done
1109 done
1110 }
1111
1112 low() { # make filenames lowercase, remove bad chars
1113 local arg new dir f
1114 for arg; do
1115 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1116 dir="${arg%/*}"
1117 if (( ${#dir} == ${#arg} )); then
1118 dir=.
1119 fi
1120 f="${arg##*/}"
1121 new="${f,,}" # downcase
1122 new="${new//[^[:alnum:]._-]/_}" # sub bad chars
1123 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1124 new="${new%"${new##*[[:alnum:]]}"}"
1125 # remove bad underscores, like __ and _._
1126 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1127 safe_rename "$dir/$f" "$dir/$new" || return 1
1128 done
1129 return 0
1130 }
1131
1132 lower() { # make first letter of filenames lowercase.
1133 local x
1134 for x in "$@"; do
1135 if [[ ${x::1} == [A-Z] ]]; then
1136 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1137 safe_rename "$x" "$y" || return 1
1138 fi
1139 done
1140 }
1141
1142
1143 k() { # history search
1144 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1145 }
1146 ks() { # history search
1147 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1148 }
1149 ccomp grep k ks
1150
1151
1152 make-targets() {
1153 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1154 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1155 }
1156
1157 mkc() {
1158 mkdir "$1"
1159 c "$1"
1160 }
1161 ccomp mkdir mkc
1162
1163 mkct() {
1164 mkc $(mktemp -d)
1165 }
1166
1167 mkt() { # mkdir and touch file
1168 local path="$1"
1169 mkdir -p "$(dirname "$path")"
1170 touch "$path"
1171 }
1172
1173 # shellcheck disable=SC2032
1174 mkdir() { command mkdir -p "$@"; }
1175
1176 nags() {
1177 # https://github.com/HenriWahl/Nagstamon/issues/357
1178 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1179 /usr/lib/notification-daemon/notification-daemon &
1180 fi
1181 /usr/bin/nagstamon &
1182 }
1183
1184 nmt() {
1185 s nmtui-connect "$@"
1186 }
1187
1188 nopanic() {
1189 # shellcheck disable=SC2024
1190 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1191 }
1192
1193 p8() { ping "$@" 8.8.8.8; }
1194 p6() { ping6 "$@" 2001:4860:4860::8888; }
1195
1196 pkx() { # package extract
1197 local pkg cached tmp f
1198 c $(mktemp -d)
1199 pkg=$1
1200 # shellcheck disable=SC2012
1201 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1202 if [[ $cached ]]; then
1203 cp $cached .
1204 else
1205 aptitude download $pkg || return 1
1206 fi
1207 tmp=(*); f=${tmp[0]} # only 1 expected
1208 ex $f
1209 rm -f $f
1210 }
1211
1212 # pgrep and kill
1213 pk1() {
1214 local pid
1215 pid=($(pgrep -f "$*"))
1216 case ${#pid[@]} in
1217 1)
1218 # shellcheck disable=SC2128
1219 {
1220 ps -F $pid
1221 m kill $pid
1222 }
1223 ;;
1224 0) echo "no pid found" ;;
1225 *)
1226 ps -F ${pid[@]}
1227 ;;
1228 esac
1229 }
1230
1231 psg () {
1232 local x y help
1233 help="Usage: psg [--help] GREP_ARGS
1234 grep ps and output in a nice format"
1235 if [[ $1 == --help ]]; then
1236 echo "$help"
1237 return
1238 fi
1239 x=$(ps -eF)
1240 # final grep is because some commands tend to have a lot of trailing spaces
1241 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1242 if [[ $y ]]; then
1243 echo "$x" | head -n 1 || [[ $? == 141 ]]
1244 echo "$y"
1245 fi
1246 }
1247
1248 pubip() { curl -4s https://icanhazip.com; }
1249 pubip6() { curl -6s https://icanhazip.com; }
1250 whatismyip() { pubip; }
1251
1252
1253 q() { # start / launch a program in the backround and redir output to null
1254 "$@" &> /dev/null &
1255 }
1256
1257 # shellcheck disable=SC2120
1258 r() {
1259 if [[ $HISTFILE ]]; then
1260 history -a # save history
1261 fi
1262 trap ERR # this avoids a segfault
1263 exit ${1:0}
1264 # i had this redir, not sure why
1265 # exit "$@" 2>/dev/null
1266 }
1267
1268 # scp is insecure and deprecated.
1269 scp() {
1270 rsync --inplace "$@"
1271 }
1272
1273 randport() {
1274 # available high ports are 1024-65535,
1275 # but lets skip things that are more likely to be in use
1276 python3 <<'EOF'
1277 import secrets
1278 print(secrets.SystemRandom().randrange(10002,65500))
1279 EOF
1280 }
1281
1282 # reapply bashrc
1283 reb() {
1284 source ~/.bashrc
1285 }
1286
1287 rl() {
1288 readlink -f "$@"
1289 }
1290 ccomp readlink rl
1291
1292 rsd() {
1293 # rsync, root is required to keep permissions right.
1294 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1295 # --no-times --delete
1296 # basically, make an exact copy, use checksums instead of file times to be more accurate
1297 rsync -ahvic --delete "$@"
1298 }
1299 rsa() {
1300 # like rlu, but dont delete files on the target end which
1301 # do not exist on the original end.
1302 rsync -ahvic "$@"
1303 }
1304 rst() {
1305 # rl without preserving modification time.
1306 rsync -ahvic --delete --no-t "$@"
1307 }
1308 rsu() { # [OPTS] HOST PATH
1309 # eg. rlu -opts frodo /testpath
1310 # relative paths will expanded with readlink -f.
1311 opts=("${@:1:$#-2}") # 1 to last -2
1312 path="${*:$#}" # last
1313 host="${*:$#-1:1}" # last -1
1314 if [[ $path == .* ]]; then
1315 path=$(readlink -f $path)
1316 fi
1317 # rync here uses checksum instead of time so we dont mess with
1318 # unison relying on time as much. g is for group, same reason
1319 # to keep up with unison.
1320 m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1321 }
1322 ccomp rsync rsd rsa rst rsu
1323
1324 resolvcat() {
1325 local f
1326 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1327 m s nscd -i hosts
1328 fi
1329 f=/etc/resolv.conf
1330 echo $f:; ccat $f
1331 hr; s ss -lpn 'sport = 53'
1332 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1333 # this will fail is dnsmasq is failed
1334 hr; m ser status dnsmasq | cat || :
1335 f=/etc/dnsmasq.conf
1336 hr; echo $f:; ccat $f
1337 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1338 f=/etc/dnsmasq-servers.conf
1339 hr; echo $f:; ccat $f
1340 fi
1341 hr
1342 echo /etc/nsswitch.conf:
1343 grep '^ *hosts:' /etc/nsswitch.conf
1344 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1345 hr; m ser status systemd-resolved | cat || :
1346 hr; m systemd-resolve --status | cat
1347 fi
1348
1349 }
1350 rcat() {
1351 resolvcat | less
1352 }
1353 reresolv() {
1354 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1355 m ser stop nscd
1356 sleep .5
1357 m ser start nscd
1358 m sudo nscd -i hosts
1359 fi
1360 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1361 m sudo systemctl restart dnsmasq
1362 fi
1363 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1364 m sudo systemctl restart systemd-resolved
1365 fi
1366 if type -P resolvectl &>/dev/null; then
1367 resolvectl flush-caches
1368 fi
1369 }
1370
1371 rmstrips() {
1372 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1373 }
1374
1375 s() {
1376 # background
1377 # I use a function because otherwise we cant use in a script,
1378 # cant assign to variable.
1379 #
1380 # note: gksudo is recommended for X apps because it does not set the
1381 # home directory to the same, and thus apps writing to ~ fuck things up
1382 # with root owned files.
1383 #
1384 if [[ $EUID != 0 || $1 == -* ]]; then
1385 # shellcheck disable=SC2034
1386 SUDOD="$PWD" command sudo -i "$@"
1387 DID_SUDO=true
1388 else
1389 "$@"
1390 fi
1391 }
1392 sb() { # sudo bash -c
1393 # use sb instead of s is for sudo redirections,
1394 # eg. sb 'echo "ok fine" > /etc/file'
1395 # shellcheck disable=SC2034
1396 local SUDOD="$PWD"
1397 sudo -i bash -c "$@"
1398 }
1399 ccomp sudo s sb
1400
1401 safe_rename() { # warn and dont rename if file exists.
1402 # mv -n exists, but it\'s silent
1403 if [[ $# != 2 ]]; then
1404 echo safe_rename error: $# args, need 2 >2
1405 return 1
1406 fi
1407 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1408 if [[ -e $2 || -L $2 ]]; then
1409 echo "Cannot rename $1 to $2 as it already exists."
1410 else
1411 mv -vi "$1" "$2"
1412 fi
1413 fi
1414 }
1415
1416
1417 sd() {
1418 sudo dd status=none of="$1"
1419 }
1420
1421 ser() {
1422 if type -p systemctl &>/dev/null; then
1423 s systemctl "$@"
1424 else
1425 if (( $# >= 3 )); then
1426 echo iank: ser expected 2 or less arguments
1427 return 1
1428 fi
1429 s service $2 $1
1430 fi
1431 }
1432 serstat() {
1433 systemctl -n 40 status "$@"
1434 }
1435
1436 seru() { systemctl --user "$@"; }
1437 # like restart, but do nothing if its not already started
1438 srestart() {
1439 local service=$1
1440 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1441 systemctl restart $service
1442 fi
1443 }
1444
1445 setini() { # set a value in a .ini style file
1446 key="$1" value="$2" section="$3" file="$4"
1447 if [[ -s $file ]]; then
1448 sed -ri -f - "$file" <<EOF
1449 # remove existing keys
1450 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1451 # add key
1452 /^\s*\[$section\]/a $key=$value
1453 # from section to eof, do nothing
1454 /^\s*\[$section\]/,\$b
1455 # on the last line, if we haven't found section yet, add section and key
1456 \$a [$section]\\
1457 $key=$value
1458 EOF
1459 else
1460 cat >"$file" <<EOF
1461 [$section]
1462 $key=$value
1463 EOF
1464 fi
1465 }
1466
1467 sgo() { # service go
1468 service=$1
1469 ser restart $service || return 1
1470 if type -p systemctl &>/dev/null; then
1471 ser enable $service
1472 fi
1473 }
1474 soff () {
1475 for service; do
1476 # ignore services that dont exist
1477 if systemctl cat $service &>/dev/null; then
1478 ser stop $service;
1479 ser disable $service
1480 fi
1481 done
1482 }
1483
1484 sgu() {
1485 systemctl list-unit-files | rg "$@"
1486 }
1487
1488
1489 sk() {
1490
1491
1492 # note, if you do something like this
1493 # x=( prefix* )
1494 # then disable the warning with:
1495 # shellcheck disable=SC2206 # globbing is intended
1496
1497 # 2029: "unescaped, this expands on the client side.": yes, I know how ssh works
1498 # 2164: "Use 'cd ... || exit' or 'cd ... || return' in case cd fails.": i have automatic error handling
1499 # 2086: unquoted $var: Quoting every var I set is way too much quotes.
1500 # 2068: Double quote array expansions to avoid re-splitting elements: same as above.
1501 # 2033: command arg is a function name: too many false positives.
1502
1503
1504 # these ones I had disabled, but without a good written explanation, so enabling them temporarily
1505 # 2046: unquoted $(cmd)
1506 # 2119: Functions with optional args get bad warnings when none are passed.
1507
1508 shellcheck -W 999 -x -e 2029,2164,2086,2068,2033 "$@" || return $?
1509 }
1510
1511
1512 # sl: ssh, but firsh rsync our bashrc and related files to a special
1513 # directory on the remote host if needed.
1514
1515 # Some environment variables and files need to be setup for this to work
1516 # (mine are set at the beginning of this file)
1517
1518 # SL_FILES_DIR: Environment variable. Path to folder which should at
1519 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1520 # remote hosts (top level symlinks are resolved) unless the host already
1521 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1522 # control and sync files to separately and already has the ~/.bashrc you
1523 # want. The remote bash will also take its .inputrc config from this
1524 # folder (default of not existing is fine). Mine looks like this:
1525 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1526
1527 # SL_INFO_DIR: Environment variable. This folder stores info about what
1528 # we detected on the remote system and when we last synced. It will be created
1529 # if it does not exist. Sometimes you may want to forget about a
1530 # remote system, you can use sl --rsync, or the function for that slr
1531 # below.
1532
1533 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1534 # depending on the remote host. Run this string on the remote host the
1535 # first time sl is run (or if we run slr). The result is passed to
1536 # SL_TEST_HOOK. For example,
1537 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1538
1539 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1540 # $SL_FILES_DIR to vary the files synced.
1541
1542 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1543 # example to exclude files within a directory. Note, excluded
1544 # files wont be deleted on rsync, you can add --delete-excluded
1545 # to the rsync command if that is desired.
1546
1547 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1548
1549 # For when ~/.bashrc is already customized on the remote server, you
1550 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1551 # commands, even in scripts. This paragraph is all about that. bash
1552 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1553 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1554 # and if you customize it, probably has bugs from time to time. This is
1555 # bad. Here's how I fix it. I have a special condition to "return" in my
1556 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1557 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1558 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1559 # separate file because even if I return early on, the whole file gets
1560 # parsed which can fail if there is a syntax error.
1561 sl() {
1562 # Background on LC_USEBASHRC var (no need to read if you just want to
1563 # use this function): env variables sent across ssh are strictly
1564 # limited, but we get LC_* at least in debian based machines, so we
1565 # just make that * be something no normal program would use. Note, on
1566 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1567 # set, and the inner shell also allows running a nondefault
1568 # .bashrc. This means the outer shell still ran the default .bashrc,
1569 # but that is the best we can do.
1570
1571 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1572 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1573 declare -a args tmpa
1574
1575 args=($SL_SSH_ARGS)
1576
1577 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1578 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1579 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1580 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1581 # [command]
1582
1583 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1584 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1585 # [-F configfile] [-I pkcs11] [-i identity_file]
1586 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1587 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1588 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1589
1590 force_rsync=false
1591 if [[ $1 == --rsync ]]; then
1592 force_rsync=true
1593 shift
1594 fi
1595
1596 sl_test_cmd=$SL_TEST_CMD
1597 sl_test_hook=$SL_TEST_HOOK
1598 sl_rsync_args=$SL_RSYNC_ARGS
1599 while [[ $1 ]]; do
1600 case "$1" in
1601 --rsync)
1602 force_rsync=true
1603 ;;
1604 --sl-test-cmd)
1605 sl_test_cmd="$2"
1606 shift
1607 ;;
1608 --sl-test-hook)
1609 sl_test_hook="$2"
1610 shift
1611 ;;
1612 --sl-rsync-args)
1613 sl_rsync_args="$2"
1614 shift
1615 ;;
1616 *)
1617 break
1618 ;;
1619 esac
1620 shift
1621 done
1622
1623 while [[ $1 ]]; do
1624 case "$1" in
1625 # note we dont support things like -4oOption
1626 -[46AaCfGgKkMNnqsTtVvXxYy]*)
1627 args+=("$1"); shift
1628 ;;
1629 -[bcDEeFIiJLlmOopQRSWw]*)
1630 # -oOption etc is valid
1631 if (( ${#1} >= 3 )); then
1632 args+=("$1"); shift
1633 else
1634 args+=("$1" "$2"); shift 2
1635 fi
1636 ;;
1637 *)
1638 break
1639 ;;
1640 esac
1641 done
1642 remote="$1"
1643 if [[ ! $remote ]]; then
1644 echo $0: error hostname required >&2
1645 return 1
1646 fi
1647 shift
1648
1649 if [[ ! $SL_INFO_DIR ]]; then
1650 echo error: missing '$SL_INFO_DIR' env var >&2
1651 return 1
1652 fi
1653
1654 dorsync=false
1655 haveinfo=false
1656 tmpa=($SL_INFO_DIR/???????????"$remote")
1657 sshinfo=${tmpa[0]}
1658 if [[ -e $sshinfo ]]; then
1659 if $force_rsync; then
1660 rm -f $sshinfo
1661 else
1662 haveinfo=true
1663 fi
1664 fi
1665 if $haveinfo; then
1666 tmp=${sshinfo[0]##*/}
1667 tmp2=${tmp::11}
1668 type=${tmp2: -1}
1669 extra_info=$(cat $sshinfo)
1670 else
1671 # we test for string to know ssh succeeded
1672 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
1673 testcmd="if $testbool; then printf y; else printf n; fi"
1674 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
1675 echo failed sl test. doing plain ssh -v
1676 command ssh -v "${args[@]}" "$remote"
1677 fi
1678 if [[ $tmp == y* ]]; then
1679 type=a
1680 else
1681 dorsync=true
1682 type=b
1683 fi
1684 extra_info="${tmp:1}"
1685 fi
1686 if [[ $sl_test_hook ]]; then
1687 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
1688 fi
1689
1690 if $haveinfo && [[ $type == b ]]; then
1691 info_sec=${tmp::10}
1692 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
1693 files_sec=${files_sec%%.*}
1694 if (( files_sec > info_sec )); then
1695 dorsync=true
1696 rm -f $sshinfo
1697 fi
1698 fi
1699
1700 sync_dirname=${SL_FILES_DIR##*/}
1701
1702 if [[ ! $SL_FILES_DIR ]]; then
1703 echo error: missing '$SL_FILES_DIR' env var >&2
1704 return 1
1705 fi
1706
1707 if $dorsync; then
1708 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
1709 fi
1710 if $dorsync || ! $haveinfo; then
1711 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
1712 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
1713 printf "%s\n" "$extra_info" >$sshinfo
1714 chmod 666 $sshinfo
1715 fi
1716 if [[ $type == b ]]; then
1717 if (( ${#@} )); then
1718 # Theres a couple ways to pass arguments, im not sure whats best,
1719 # but relying on bash 4.4+ escape quoting seems most reliable.
1720 command ssh "${args[@]}" "$remote" \
1721 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
1722 elif [[ ! -t 0 ]]; then
1723 # This case is when commands are being piped to ssh.
1724 # Normally, no bashrc gets sourced.
1725 # But, since we are doing all this, lets source it because we can.
1726 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1727 else
1728 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
1729 fi
1730 else
1731 if [[ -t 0 ]]; then
1732 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
1733 else
1734 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1735 fi
1736 fi
1737 # this function inspired from https://github.com/Russell91/sshrc
1738 }
1739
1740 slr() {
1741 sl --rsync "$@"
1742 }
1743 sss() { # ssh solo
1744 sl -oControlMaster=no -oControlPath=/ "$@"
1745 }
1746 # kill off old shared socket then ssh
1747 ssk() {
1748 m ssh -O exit "$@" || [[ $? == 255 ]]
1749 m sl "$@"
1750 }
1751 ccomp ssh sl slr sss ssk
1752 # plain ssh
1753 ssh() {
1754 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
1755 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
1756 else
1757 LC_USEBASHRC=t command ssh "$@"
1758 fi
1759 }
1760
1761
1762 slog() {
1763 # log with script. timing is $1.t and script is $1.s
1764 # -l to save to ~/typescripts/
1765 # -t to add a timestamp to the filenames
1766 local logdir do_stamp arg_base
1767 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1768 logdir="/a/dt/"
1769 do_stamp=false
1770 while getopts "lt" option
1771 do
1772 case $option in
1773 l ) arg_base=$logdir ;;
1774 t ) do_stamp=true ;;
1775 esac
1776 done
1777 shift $((OPTIND - 1))
1778 arg_base+=$1
1779 [[ -e $logdir ]] || mkdir -p $logdir
1780 $do_stamp && arg_base+=$(date +%F.%T%z)
1781 script -t $arg_base.s 2> $arg_base.t
1782 }
1783 splay() { # script replay
1784 #logRoot="$HOME/typescripts/"
1785 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1786 scriptreplay "$1.t" "$1.s"
1787 }
1788
1789 sr() {
1790 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1791 if [[ $# == 0 ]]; then
1792 sudo -E bash -c -l "$(history -p '!!')"
1793 else
1794 echo this command redos last history item. no argument is accepted
1795 fi
1796 }
1797
1798 srm () {
1799 # with -ll, less secure but faster.
1800 command srm -ll "$@"
1801 }
1802
1803 srun() {
1804 scp $2 $1:/tmp
1805 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
1806 }
1807
1808
1809 swap() {
1810 local tmp
1811 tmp=$(mktemp)
1812 mv $1 $tmp
1813 mv $2 $1
1814 mv $tmp $2
1815 }
1816
1817 tclock() { # terminal clock
1818 local x
1819 clear
1820 date +%l:%_M
1821 len=60
1822 # this goes to full width
1823 #len=${1:-$((COLUMNS -7))}
1824 x=1
1825 while true; do
1826 if (( x == len )); then
1827 end=true
1828 d="$(date +%l:%_M) "
1829 else
1830 end=false
1831 d=$(date +%l:%M:%_S)
1832 fi
1833 echo -en "\r"
1834 echo -n "$d"
1835 for ((i=0; i<x; i++)); do
1836 if (( i % 6 )); then
1837 echo -n _
1838 else
1839 echo -n .
1840 fi
1841 done
1842 if $end; then
1843 echo
1844 x=1
1845 else
1846 x=$((x+1))
1847 fi
1848 sleep 5
1849 done
1850 }
1851
1852
1853 te() {
1854 # test existence / exists
1855 local ret=0
1856 for x in "$@"; do
1857 [[ -e "$x" || -L "$x" ]] || ret=1
1858 done
1859 return $ret
1860 }
1861
1862 psoff() {
1863 # normally, i would just execute these commands in the function.
1864 # however, DEBUG is not inherited, so we need to run it outside a function.
1865 # And we want to run set -x afterwards to avoid spam, so we cram everything
1866 # in here, and then it will run after this function is done.
1867 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
1868 }
1869 pson() {
1870 PROMPT_COMMAND=prompt-command
1871 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
1872 trap 'settitle "$BASH_COMMAND"' DEBUG
1873 fi
1874 }
1875
1876 tx() { # toggle set -x, and the prompt so it doesnt spam
1877 if [[ $- == *x* ]]; then
1878 set +x
1879 pson
1880 else
1881 psoff
1882 fi
1883 }
1884
1885 psnetns() {
1886 # show all processes in the network namespace $1.
1887 # blank entries appear to be subprocesses/threads
1888 local x netns
1889 netns=$1
1890 ps -w | head -n 1
1891 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
1892 while read -r l; do
1893 x=$(ps -w --no-headers -p $l);
1894 if [[ $x ]]; then echo "$x"; else echo $l; fi;
1895 done
1896 }
1897
1898 m() { printf "%s\n" "$*"; "$@"; }
1899
1900 uptime() {
1901 if type -p uprecords &>/dev/null; then
1902 uprecords -B
1903 else
1904 command uptime
1905 fi
1906 }
1907
1908 virshrm() {
1909 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1910 }
1911
1912 vm-set-listen(){
1913 local t
1914 t=$(mktemp)
1915 local vm=$1
1916 local ip=$2
1917 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1918 sed -r "s/listen='[^']+/listen='$ip/"> $t
1919 sudo virsh undefine $vm
1920 sudo virsh define $t
1921 }
1922
1923
1924 vmshare() {
1925 vm-set-listen $1 0.0.0.0
1926 }
1927
1928
1929 vmunshare() {
1930 vm-set-listen $1 127.0.0.1
1931 }
1932
1933 myiwscan() {
1934 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
1935 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
1936 sudo iw dev wls1 scan | sed -rn "
1937 s/^\Wcapability: (.*)/\1/;Ta;h;b
1938 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
1939 # padded to min width of 20
1940 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
1941 "|sort -r
1942 }
1943
1944 # * misc stuff
1945
1946
1947 if $use_color && type -p tput &>/dev/null; then
1948 term_bold="$(tput bold)"
1949 term_red="$(tput setaf 1)"
1950 term_green="$(tput setaf 2)"
1951 term_yellow="$(tput setaf 3)"
1952 term_purple="$(tput setaf 5)"
1953 term_nocolor="$(tput sgr0)" # no font attributes
1954
1955 # unused so far. commented for shellcheck
1956 # term_underl="$(tput smul)"
1957 # term_blue="$(tput setaf 4)"
1958 # term_cyan="$(tput setaf 6)"
1959 fi
1960 # Try to keep environment pollution down, EPA loves us.
1961 unset safe_term match_lhs use_color
1962
1963 # * prompt
1964
1965
1966 if [[ $- == *i* ]]; then
1967
1968
1969 case $HOSTNAME in
1970 bk|je|li)
1971 if [[ $EUID == 1000 ]]; then
1972 system-status _ ||:
1973 fi
1974 ;;
1975 esac
1976
1977
1978 # this needs to come before next ps1 stuff
1979 # this stuff needs bash 4, feb 2009,
1980 # old enough to no longer condition on $BASH_VERSION anymore
1981 shopt -s autocd
1982 shopt -s dirspell
1983 PS1='\w'
1984 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
1985 PROMPT_DIRTRIM=2
1986 bind -m vi-command B:shell-backward-word
1987 bind -m vi-command W:shell-forward-word
1988 fi
1989
1990 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
1991 unset PROMPT_DIRTRIM
1992 PS1="\h:$PS1"
1993 fi
1994
1995 # emacs terminal has problems if this runs slowly,
1996 # so I've thrown a bunch of things at the wall to speed it up.
1997 prompt-command() {
1998 local return=$? # this MUST COME FIRST
1999 local ps_char ps_color
2000 unset IFS
2001
2002 if [[ $HISTFILE ]]; then
2003 history -a # save history
2004 fi
2005
2006 # assigned in brc2
2007 # shellcheck disable=SC1303
2008 if [[ $jr_pid ]]; then
2009 if [[ -e /proc/$jr_pid ]]; then
2010 kill $jr_pid
2011 fi
2012 unset jr_pid
2013 fi
2014
2015 case $return in
2016 0) ps_color="$term_purple"
2017 ps_char='\$'
2018 ;;
2019 *) ps_color="$term_green"
2020 ps_char="$return \\$"
2021 ;;
2022 esac
2023 if [[ ! -O . ]]; then # not owner
2024 if [[ -w . ]]; then # writable
2025 ps_color="$term_bold$term_red"
2026 else
2027 ps_color="$term_bold$term_green"
2028 fi
2029 fi
2030
2031 # faster than sourceing the file im guessing
2032 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2033 eval $(< /dev/shm/iank-status)
2034 fi
2035 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2036 ps_char="@ $ps_char"
2037 fi
2038 # We could test if sudo is active with sudo -nv
2039 # but then we get an email and log of lots of failed sudo commands.
2040 # We could turn those off, but seems better not to.
2041 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2042 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2043 fi
2044 if [[ ! $HISTFILE ]]; then
2045 ps_char="NOHIST $ps_char"
2046 fi
2047 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2048
2049 # set titlebar. instead, using more advanced
2050 # titelbar below
2051 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2052 }
2053 PROMPT_COMMAND=prompt-command
2054
2055 if [[ $TERM == screen* ]]; then
2056 _title_escape="\033]..2;"
2057 else
2058 # somme sites recommend this, i dunno what the diff is.
2059 #_title_escape="\033]30;"
2060 _title_escape="\033]0;"
2061 fi
2062
2063 settitle () {
2064 # this makes it so we show the current command if
2065 # one is running, otherwise, show nothing
2066
2067 if [[ $1 == prompt-command ]]; then
2068 return 0
2069 fi
2070 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2071 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2072 printf "%s" "$*"
2073 echo -ne "\007"
2074 fi
2075 }
2076
2077 # note, this wont work:
2078 # x=$(mktemp); cp a $x
2079 # I havnt figured out why, bigger fish to fry.
2080 #
2081 # for titlebar.
2082 # condition from the screen man page i think.
2083 # note: duplicated in tx()
2084 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2085 trap 'settitle "$BASH_COMMAND"' DEBUG
2086 else
2087 trap DEBUG
2088 fi
2089
2090 fi
2091
2092 # * stuff that makes sense to be at the end
2093
2094
2095 # best practice
2096 unset IFS
2097
2098 # shellcheck disable=SC1090
2099 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2100
2101 # I had this idea to start a bash shell which would run an initial
2102 # command passed through this env variable, then continue on
2103 # interactively. But the use case I had in mind went away.
2104 #
2105 # if [[ $MY_INIT_CMD ]]; then
2106 # "${MY_INIT_CMD[@]}"
2107 # unset MY_INIT_CMD
2108 # fi
2109
2110 # ensure no bad programs appending to this file will have an affect
2111 return 0